var company_details = {
    settings: {
        userAjaxUrl: '',
        branchAjaxUrl: '',
        smsAjaxUrl: '',
        id:''
    },
    init: function() {
        company_details.initUserDataTable();
        company_details.initBranchDataTable();
        company_details.initSmsDataTable();
        company_details.initForm();

    },
    initUserDataTable: function() {

        var callBack = function() {
        };

        company_details.dataList = $('#user-datalist').DataTable({
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': company_details.settings.userAjaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.companyId = company_details.settings.id; 
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 4 },
                { 'searchable': false, 'targets': 4 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });

        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },

    initBranchDataTable: function() {

        var callBack = function() {
        };
    
        company_details.dataList = $('#branch-datalist').DataTable({
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': company_details.settings.branchAjaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.companyId = company_details.settings.id; 
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 2 },
                { 'searchable': false, 'targets': 2 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });
    
        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },

    initSmsDataTable: function() {

        var callBack = function() {
            company_details.initForm();
        };
    
        company_details.smsDataList = $('#sms-datalist').DataTable({
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': company_details.settings.smsAjaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.companyId = company_details.settings.id; 
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 1 },
                { 'searchable': false, 'targets': 1 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });
    
        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },
    initForm: function(){
        
        $('.href-modal').unbind('click').bind('click',function(){
            var _this = $(this);
            
            $('.modal').removeClass('modal-fullscreen');

            
            $.ajax({
                url: _this.data('url'),
                type: 'POST',
                data: { id: _this.data('id'), action: _this.data('action'), companyId: _this.data('companyid')},
                beforeSend: function(){
                $(".modal-content").html('');
                    
                },
                success: function(r){
                    if(r.success){
                
                        $(".modal-content").html(r.html);
                        $('#modal').modal('show');
                    }
                }
            });
        });
        
    },
};