var grooming_payment_ajax = {
    settings: {
        ajaxUrl: '',
        groomingId: '',
        ajax_form_process: ''
        
    },
    init: function() {
        grooming_payment_ajax.initDataTable();
        grooming_payment_ajax.initForm();
        grooming_payment_ajax.bindAutoComplete();
    },

    loadParentForm: function(){
        
    },

    initForm: function(){

        $.each($('.href-form'), function(){
            var _this = $(this);  
            _this.unbind('click').bind('click',function(){
            
                $.ajax({
                    url: _this.data('url'),
                    type: 'POST',
                    data: { groomingId:_this.data('groomingid') ,id: _this.data('id'), action: _this.data('action')},
                    beforeSend: function(){
    
                        if(!_this.hasClass('fullscreen')){
                            $('.modal').removeClass('modal-fullscreen');
            
                        } else {
                            $('.modal').addClass('modal-fullscreen');
                        }
            
                        $(".modal-content").html('');
                        $('.loading').removeClass('hidden');
                        $("#ui-datepicker-div").remove();
                        $(".ui-timepicker-container").remove();
                    },
                    success: function(r){
                        if(r.success){
                        
                            if(r.success){
                            
                                $('.loading').addClass('hidden');
                                $(".modal-content").html(r.html);
                                grooming_payment_ajax.bindInputElem();
                            }
                         
        
                        } else {
                            $.toaster({ message : r.msg, title : '', priority : 'danger' });
                            btn.prop('disabled', false);
                            $('.loading').addClass('hidden');
                        }
                    }
                });
            });
    
            
        });
        
    },
    initDataTable: function() {

        var callBack = function() {
            grooming_payment_ajax.initForm();
        };

        grooming_payment_ajax.dataList = $('#groomingPayment-datalist').DataTable({
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': grooming_payment_ajax.settings.ajaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.groomingId = grooming_payment_ajax.settings.groomingId;
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 3},
                { 'searchable': false, 'targets': 3 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });

        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },
    bindAutoComplete: function(){
        global.autocomplete.bind(this.settings.paymentTypeAutoCompleteUrl,'#payment_form_grooming_payment_ajax_desc','#payment_form_grooming_payment_ajax');

    },
    bindInputElem: function(){
        
        $('.cancel-child-form').unbind('click').bind('click',function(){

            var _this = $(this);

            if(!_this.hasClass('fullscreen')){
                $('.modal').removeClass('modal-fullscreen');

            } else {
                $('.modal').addClass('modal-fullscreen');
            }

            $.ajax({
                url: _this.data('parenturl'),
                type: 'POST',
                async:false,
                data: { id: _this.data('id'), action: _this.data('action')},
                beforeSend: function(){
                    $(".modal-content").html('');
                    
                },
                success: function(r){
                    if(r.success){
                
                        $(".modal-content").html(r.html);
                        $('#modal').modal('show');
                    }
                }
            });
        })

    }
};