var lodge_dashboard = {
    settings: {
        ajaxSalesInfoUrl: '',
        ajaxSalesAnalyticsUrl: ''
    },
    init: function() {
        lodge_dashboard.getSalesInfo();
        lodge_dashboard.bindInput();
    },

   getSalesInfo: function(){
        
        $.ajax({
            url : lodge_dashboard.settings.ajaxSalesInfoUrl,
            success: function(r){
                if(r.success){
                    $('#dailySales').html(r.salesInfo[0]['dailySales']);
                    $('#weeklySales').html(r.salesInfo[0]['weeklySales']);
                    $('#monthlySales').html(r.salesInfo[0]['monthlySales']);
                }
            }
        });

        lodge_dashboard.toggleGraphData();

       
   },

   bindInput: function(){

        $.each($('.graph-toggler'),function(){
            var _this = $(this);
            _this.unbind('click').bind('click',function(){
                $('.active-chart').removeClass('active-chart');
                _this.toggleClass('active-chart');
                lodge_dashboard.toggleGraphData(_this);
            });
        });
   },

   toggleGraphData: function(e){
       var t = ''; 
       if(typeof e == 'object'){
             t = e.data('type');
       }
        $.ajax({
            url : lodge_dashboard.settings.ajaxSalesAnalyticsUrl + '?t=' + t ,
            success: function(r){
                if(r.success){
                    lodge_dashboard.initGraph(r);
                }
            }
        })
   },

   initGraph: function(r){
        
        var salesChartCanvas = document.getElementById('revenue-chart-canvas').getContext('2d')
        var salesChartData = {
            labels: r.days,
            datasets: [{
                label: 'Sales',
                backgroundColor: 'rgba(60,141,188,0.9)',
                borderColor: 'rgba(60,141,188,0.8)',
                pointRadius: false,
                pointColor: '#3b8bba',
                pointStrokeColor: 'rgba(60,141,188,1)',
                pointHighlightFill: '#fff',
                pointHighlightStroke: 'rgba(60,141,188,1)',
                data: r.stats
            }]
        }

        var salesChartOptions = {
            maintainAspectRatio: false,
            responsive: true,
            legend: {
                display: false
            },
            scales: {
                xAxes: [{
                    gridLines: {
                        display: false
                    }
                }],
                yAxes: [{
                    gridLines: {
                        display: false
                    }
                }]
            }
        }
        var salesChart = new Chart(salesChartCanvas,{
            type: 'line',
            data: salesChartData,
            options: salesChartOptions
        })
   }
};