var lodge_payment = {
    settings: {
        ajaxUrl: ''
    },
    init: function() {
        lodge_payment.initDataTable();
    },
    initDataTable: function() {

        var callBack = function() {
            $('#dateFrom,#dateTo' ).unbind('change').bind('change', function(){
                lodge_payment.dataList.draw();
            });
        };
        lodge_payment.dataList = $('#lodgePayment-datalist').DataTable({
            "searching": false,
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': lodge_payment.settings.ajaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.dateFrom = $('#dateFrom').val();
                    d.dateTo = $('#dateTo').val();
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 2 },
                { 'searchable': false, 'targets': 2 }
            ],
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });

        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    }
};