var schedule = {
    settings: {
        ajaxUrl: '',
        scheduleDataAjaxUrl: '',
        formAjaxUrl: ''
    },
    init: function() {
        schedule.initDataTable();
        schedule.getScheduleData();
    },

    getScheduleData: function(){

        $.ajax({
            url : schedule.settings.scheduleDataAjaxUrl,
            success: function(s){

                var events = [];
                $.each(s, function( index, value ) {
                    var data = { 
                        id: value.id,
                        start : new Date(value.scheduleYear, value.scheduleMonth - 1, value.scheduleDay), 
                        title: value.schedules,
                        allDay: true,
                        backgroundColor: value.bgColor, 
                        borderColor    :  value.bgColor
                    };
                   
                    events.push(data);
                });

                schedule.initCalendar(events);                
            }
        });
    },
    initDataTable: function() {

        var callBack = function() {
        };

        schedule.dataList = $('#schedule-datalist').DataTable({
            'order': [[4, 'ASC']],
            'processing': true,
            'serverSide': true,
            "lengthChange": false,
            "pageLength": 20,
            'ajax': {
                'url': schedule.settings.ajaxUrl,
                'data': function(d) {
                    d.url = global.settings.url;
                    d.startDate = $('#startDate').val();
                    d.endDate = $('#endDate').val();
                }
            },
            'deferRender': true,
            'columnDefs': [
                { 'orderable': false, 'targets': 5 },
                { 'searchable': false, 'targets': 5 }
            ],
            createdRow: function( row, data, dataIndex ) {
                // Set the data-status attribute, and add a class
               var dataType =  $( row ).find('td:eq(5)').find('.table-btn').attr('data-type');

               if(dataType == 'follow-up'){
                
                    $( row ).css('background-color' , '#7bc234');
               } else {

               }
            },
            drawCallback: function() {
                callBack();
            },
            responsive: {
                details: {
                    renderer: function( api,rowIdx ) {
                        return global.dataTableResponsiveCallBack(api, rowIdx, callBack);
                    }
                }
            }
        });

        $('.content-container').removeClass('has-loading');
        $('.content-container-content').removeClass('hide');
    },
    initCalendar : function(events){
            
        var Calendar = FullCalendar.Calendar;
        var calendarEl = document.getElementById('calendar');


        schedule.calendar = new Calendar(calendarEl, {
                dateClick: function(info) {
                    //window.location = '/schedule/form/n/0?date=' + info.dateStr;
                },
                headerToolbar: {
                    left  : 'prev,next today new',
                    center: 'title',
                    right : 'dayGridMonth'
                },
                themeSystem: 'bootstrap',
                events: events,
                eventOrder: "schedules",
                eventStartEditable: false,
                droppable : false, 
                eventClick: function(event) {

                    $.ajax({
                        url: schedule.settings.formAjaxUrl,
                        type: 'POST',
                        data: { id: event.event.id, action: 'u'},
                        beforeSend: function(){
                        $(".modal-content").html('');
                            
                        },
                        success: function(r){
                            if(r.success){
                        
                                $(".modal-content").html(r.html);
                                $('#modal').modal('show');
                            }
                        }
                    });
                },
                eventDidMount: function(info) {
                    console.log(info);
                }
            }
        );

        schedule.calendar.render();
        $('.fc-daygrid-event ').css('cursor', 'pointer');
        $('.fc-new-button').html('New Schedule');
        $('.fc-re-schedule-button').addClass('btn-success');
    
        $('.fc-new-button').unbind('click').bind('click',function(){
             
            $.ajax({
                url: schedule.settings.formAjaxUrl,
                type: 'POST',
                data: { id: 0, action: 'n'},
                beforeSend: function(){
                $(".modal-content").html('');
                    
                },
                success: function(r){
                    if(r.success){
                
                        $(".modal-content").html(r.html);
                        $('#modal').modal('show');
                    }
                }
            });
        });
    }
};