<?php

namespace App\Repository;

use App\Entity\GroomingEntity;
use App\Entity\BranchEntity;


/**
 * GroomingRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class GroomingRepository extends \Doctrine\ORM\EntityRepository
{
    public function validate($form) {

        $errors = array();


        $action = $form['action'];

        // d = delete
        if($action !== 'd') {

            
            if(empty($form['client_pet'])){
                $errors[] = 'Pet should not be empty.';
            }


            if(isset($form['groomingService'])){
         
                foreach ($form['groomingService'] as $key => $i) {
                    if(empty($i['service'])){
                        $errors[] = 'Service in should not be empty.';
                    }
                    if(empty($i['staff'])){
                        $errors[] = 'Staff in should not be empty.';
                    }
                }
            }

            if(isset($form['is_ready_for_pick_up'])){

                $isServiceNotCompleted = false;

                if(isset($form['groomingService'])){
                    foreach ($form['groomingService'] as $key => $i) {
                        if($i['status'] != 'Completed'){
                            $isServiceNotCompleted = true;

                        }
                    }
                }

                if($isServiceNotCompleted){
                    $errors[] = 'There are service that is not yet completed.';
                }
            }

          
        }

        return $errors;
    }

    public function ajax_list(array $get, array $userData){

        $columns = array(
            array('CONCAT(c.`first_name` , " " , c.`last_name` , " - " , cp.`pet_name`)','CONCAT(c.`first_name` , " " , c.`last_name` , " - " , cp.`pet_name`)', 'client'),
            array('gs.amtDue', 'gs.amtDue', 'amtDue'),
            array('g.`status`', 'g.`status`', 'status'),
            array('g.`id`', "g.`id`")
        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `grooming` g";
        $joins = "LEFT JOIN `client_pet` cp ON cp.`id` = g.`client_pet_id`";
        $joins .= "LEFT JOIN `client` c ON c.`id` = cp.`client_id`";
        $joins .= "LEFT JOIN (
            SELECT 
                SUM(gs.`service_rate`) AS amtDue,
                gs.`id`,
                gs.`grooming_id`
            FROM `grooming_service` gs
            GROUP BY gs.`grooming_id`    
        ) gs ON gs.`grooming_id` = g.`id`";

        $sqlWhere = "WHERE g.`is_deleted` = 0";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();

        if($userData['type'] != 'Super Admin'){

            $sqlWhere .= " AND g.`branch_id` = :branchId";
            $stmtParams['branchId'] =  base64_decode($userData['branchId']);
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = '';
        $hasUpdate = false;

        if($userData['type'] == 'Super Admin'|| in_array('Grooming Update', $userData['accesses'])){

            $formUrl = $url . '/grooming/ajax_form';  
            $hasUpdate = true;
        }

        foreach($result as $row) {

            $id = base64_encode($row['id']);

            $action = $hasUpdate ? '<a href="javascript:void(0);" class="href-modal action-btn action-button-style btn btn-primary table-btn fullscreen" data-id="'.$id.'"  data-url="'.$formUrl.'" data-action="u">Update</a>' : "";

            $values = array(
                $row['client'],
                $row['amtDue'],
                $row['status'],
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);

        return $output;
    }

    public function autocomplete_suggestions($q, array $userData) {
       
        $stmtParams = array();

        $qs = $q['query'];

        $where = ' WHERE b.`description` LIKE :description';
        $stmtParams['description'] =  "%$qs%"; 

        if($userData['type'] != 'Super Admin' ){

            $where.= ' AND b.`branch_id` = :branchId';
            $stmtParams['branchId'] = base64_decode($userData['branchId']);
        }
      
        $sql = "
            SELECT
                 b.`id`,
                 b.`description` AS data,
                 b.`description` AS value
            FROM `grooming` b
            ". $where ."
            AND b.`is_deleted` = 0
            ORDER BY b.`description`
            LIMIT 0,20
        ";


        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    public function getByBranch($user){
        
        $branchId = $user->getBranch()->getId();
      
        $sql = "
            SELECT
                r.`id`,
                r.`grooming_rate` AS groomingRate,
                rt.`description` AS groomingType,
                r.status,
                r.`description` AS grooming
            FROM `grooming` r
            LEFT JOIN `grooming_type` rt ON rt.`id` = r.`grooming_type_id`
            WHERE r.`branch_id` = ".$branchId."
            AND r.`is_deleted` = 0
           
        ";


        $query = $this->getEntityManager()->getConnection()->prepare($sql);

       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;

    }

    public function getSalesInfo(array $userData){

        $andWhere = '';
        $timestamp    = strtotime(date("F Y"));
        $dailyCon = ' WHERE gp.`payment_date` BETWEEN "'.date("Y-m-d 00:00:00").'" AND "'.date("Y-m-d 23:59:59") .'"';
        $weeklyCon  = 'WHERE gp.`payment_date` BETWEEN "'.date("Y-m-d", strtotime('monday this week')) . ' 00:00:00"'.' AND "'.date("Y-m-d", strtotime('sunday this week')) . ' 23:59:59' .'"';
        $monthlyCon = 'WHERE gp.`payment_date` BETWEEN "'.date('Y-m-01 00:00:00', $timestamp).'" AND "'.  date('Y-m-t 12:59:59', $timestamp) . '"';

        if($userData['type'] != 'Super Admin'){

             $andWhere.= ' WHERE g.branch_id = "' .base64_decode($userData['branchId'])  .'"'; 
        }


        $query = $this->getEntityManager()->getConnection()->prepare("
            SELECT
               SUM(IFNULL( daily.dailySales, 0)) AS dailySales,
               SUM(IFNULL( weekly.weeklySales, 0)) AS weeklySales,
               SUM(IFNULL(  monthly.monthlySales, 0)) AS monthlySales
            FROM `grooming` g
            LEFT JOIN (
                SELECT 
                    SUM(gp.`amount`) AS dailySales,
                    gp.`grooming_id` AS groomingId
                FROM `grooming_payment` gp
                ".$dailyCon."
                AND gp.`is_deleted` != 1
                GROUP BY gp.`grooming_id`   
            ) daily ON daily.groomingId = g.`id`
            LEFT JOIN (
                SELECT 
                    SUM(gp.`amount`) AS weeklySales,
                    gp.`grooming_id` AS groomingId
                FROM `grooming_payment` gp
                ".$weeklyCon."
                AND gp.`is_deleted` != 1
                GROUP BY gp.`grooming_id`   
            ) weekly ON weekly.groomingId = g.`id`
            LEFT JOIN (
                SELECT 
                    SUM(gp.`amount`) AS monthlySales,
                    gp.`grooming_id` AS groomingId
                FROM `grooming_payment` gp
                ".$monthlyCon."
                AND gp.`is_deleted` != 1
                GROUP BY gp.`grooming_id`   
            ) monthly ON monthly.groomingId = g.`id`
            $andWhere
        ");

   
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    public function getSalesAnalytics($get, array $userData){

        $result = $this->getDailyAnalytics($userData);

        if(isset($get['t']) && $get['t'] == 'm' ){

            return  $this->getMonthlyAnalytics($userData);
        } else if($get['t'] == 'w'){
            return  $this->getWeeklyAnalytics($userData);

        }
 

        return $result;
    }

    private function getDailyAnalytics(array $userData){

        $stmtParams =[];
        $andWhere = '';

        if($userData['type'] != 'Super Admin'){

             $andWhere.= ' WHERE g.`branch_id` = "' . base64_decode($userData['branchId']) .'"' ;   
        }
       
        $firstDay  = date("Y-m-d ");
        $lastDay = date("Y-m-d 23:59:59");
        $query = $this->getEntityManager()->getConnection()->prepare("
            with recursive cte as (
                select '".$firstDay." 00:00:00' dt
                union all 
                select dt + interval 1 hour from cte where dt < '".$lastDay."' - interval 1 hour
            )
            select
                row_number() over(order by cte.`dt`) id,
                DATE_FORMAT(cte.`dt`, '%h %p') as dayMonth,
                IFNULL(gp.amount, 0) as amount
            from `cte` cte 
            LEFT JOIN(
                SELECT 
                SUM( gp.`amount`) as amount,
                gp.`payment_date` as paymentDate
                FROM `grooming_payment` gp
                LEFT JOIN `grooming` g ON g.`id` = gp.`grooming_id`
                ".$andWhere."
                AND gp.`is_deleted` != 1
                GROUP BY DATE_FORMAT(gp.`payment_date`, '%Y/%m/%d %h %p')     
                ) gp ON DATE_FORMAT(gp.paymentDate, '%Y/%m/%d %h %p') = DATE_FORMAT(cte.`dt`, '%Y/%m/%d %h %p')
        ");

       


        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    private function getWeeklyAnalytics(array $userData){

        $stmtParams =[];
        $andWhere = '';

        if($userData['type'] != 'Super Admin'){

             $andWhere.= ' WHERE g.`branch_id` = "' . base64_decode($userData['branchId']) .'"' ;   
        }
       
        $firstDay  = date("Y-m-d", strtotime("monday this week"));
        $lastDay = date("Y-m-d 23:59:59", strtotime("sunday this week"));
        $query = $this->getEntityManager()->getConnection()->prepare("
                with recursive cte as (
                    select '".$firstDay." 00:00:00' dt
                    union all 
                    select dt + interval 1 day from cte where dt < '".$lastDay."' - interval 1 day
                )
                select
                    row_number() over(order by cte.`dt`) id,
                    DATE_FORMAT(cte.`dt`, '%d') as dayMonth,
                    IFNULL(gp.amount, 0) as amount
                from `cte` cte 
                LEFT JOIN(
                    SELECT 
                       SUM( gp.`amount`) as amount,
                       gp.`payment_date` as paymentDate
                    FROM `grooming_payment` gp
                    LEFT JOIN `grooming` g ON g.`id` = gp.`grooming_id`
                    ".$andWhere."
                    AND gp.`is_deleted` != 1
                    GROUP BY DATE_FORMAT(gp.`payment_date`, '%Y/%m/%d')     
                    ) gp ON DATE_FORMAT(gp.paymentDate, '%Y/%m/%d') = DATE_FORMAT(cte.`dt`, '%Y/%m/%d')
        ");

       


        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    private function getMonthlyAnalytics(array $userData){

        $stmtParams =[];
        $andWhere = '';

        if($userData['type'] != 'Super Admin'){

             $andWhere.= ' WHERE g.`branch_id` = "' . base64_decode($userData['branchId']) .'"' ;   
        }
       
        $firstDay  = date("Y-m-d", strtotime("first day of this month"));
        $lastDay = date("Y-m-d 23:59:59", strtotime("last day of this month"));

        $query = $this->getEntityManager()->getConnection()->prepare("
                with recursive cte as (
                    select '".$firstDay." 00:00:00' dt
                    union all 
                    select dt + interval 1 day from cte where dt < '".$lastDay."' - interval 1 day
                )
                select
                    row_number() over(order by cte.`dt`) id,
                    DATE_FORMAT(cte.`dt`, '%d') as dayMonth,
                    IFNULL(gp.amount, 0) as amount
                from `cte` cte 
                LEFT JOIN(
                    SELECT 
                       SUM( gp.`amount`) as amount,
                       gp.`payment_date` as paymentDate
                    FROM `grooming_payment` gp
                    LEFT JOIN `grooming` g ON g.`id` = gp.`grooming_id`
                    ".$andWhere."
                    GROUP BY DATE_FORMAT(gp.`payment_date`, '%Y/%m/%d')     
                    ) gp ON DATE_FORMAT(gp.paymentDate, '%Y/%m/%d') = DATE_FORMAT(cte.`dt`, '%Y/%m/%d')
        ");

       


        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;
    }

    
    public function transaction_ajax_list(array $get, array $userData){

        $columns = array(
            array('l.`transaction_no`', 'l.`transaction_no`', 'transactionNo'),
            array('CONCAT(c.`first_name`, " " , c.`last_name`)','CONCAT(c.`first_name`, " " , c.`last_name`)', 'client'),
            array('lp.paymentType', 'lp.paymentType', 'paymentTypes'),
            array('lp.paymentDate', 'lp.paymentDate', 'paymentDates'),
            array('lp.paymentAmt', 'lp.paymentAmt', 'paymentAmts'),
            array('l.`billed_amount`', 'l.`billed_amount`', 'billedAmt'),
            array('l.`id`', "l.`id`")
        );
        $asColumns = array();

        $select = "SELECT";
        $from = "FROM `grooming` l";
        $joins = "LEFT JOIN `client_pet` cp ON cp.`id` = l.`client_pet_id`";
        $joins .= "LEFT JOIN `client` c ON c.`id` = cp.`client_id`";
        $joins .= "LEFT JOIN (
            SELECT 
                GROUP_CONCAT(pt.`description`) AS paymentType,
                GROUP_CONCAT(DATE_FORMAT(lp.`payment_date`, '%m/%d/%Y')) AS paymentDate,
                GROUP_CONCAT(lp.`amount`) AS paymentAmt,
                lp.`grooming_id`
            FROM `grooming_payment` lp
            LEFT JOIN `payment_type` pt ON pt.`id` = lp.`payment_type_id`
            WHERE (lp.`is_deleted` = 0 OR lp.`is_deleted` IS NULL)
            GROUP BY lp.`grooming_id`
        ) lp ON lp.`grooming_id` = l.`id`";
        $sqlWhere = "";
        $groupBy = "";
        $orderBy = "";
        $limit = "";
        $stmtParams = array();

        if($userData['type'] != 'Super Admin'){

            $sqlWhere .= " Where l.`branch_id` = :branchId";
            $stmtParams['branchId'] =  base64_decode($userData['branchId']);
        }

        foreach($columns as $key => $column) {
            $select .= ($key > 0 ? ', ' : ' ') . $column[1] . (isset($column[2]) ? ' AS ' . $column[2] : '');
        }

        /*
         * Ordering
         */
        foreach($get['columns'] as $key => $column) {
            if($column['orderable']=='true') {
                if(isSet($get['order'])) {
                    foreach($get['order'] as $order) {
                        if($order['column']==$key) {
                            $orderBy .= (!empty($orderBy) ? ', ' : 'ORDER BY ') . $columns[$key][0] . (!empty($order['dir']) ? ' ' . $order['dir'] : '');
                        }
                    }
                }
            }
        }

        /*
         * Filtering
         */
        if(isset($get['search']) && $get['search']['value'] != ''){
            $aLikes = array();
            foreach($get['columns'] as $key => $column) {
                if($column['searchable']=='true') {
                    $aLikes[] = $columns[$key][0] . ' LIKE :searchValue';
                }
            }
            foreach($asColumns as $asColumn) {
                $aLikes[] = $asColumn . ' LIKE :searchValue';
            }
            if(count($aLikes)) {
                $sqlWhere .= (!empty($sqlWhere) ? ' AND ' : 'WHERE ') . '(' . implode(' OR ', $aLikes) . ')';
                $stmtParams['searchValue'] = "%" . $get['search']['value'] . "%";
            }
        }

        /* Set Limit and Length */
        if(isset( $get['start'] ) && $get['length'] != '-1'){
            $limit = 'LIMIT ' . (int)$get['start'] . ',' . (int)$get['length'];
        }

        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);

        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result_count = $res->fetchAllAssociative();




        $sql = "$select $from $joins $sqlWhere $groupBy $orderBy $limit";
        $query = $this->getEntityManager()->getConnection()->prepare($sql);
        foreach($stmtParams as $k => $v){
            $query->bindValue($k, $v);

        }
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        /* Data Count */
        $recordsTotal = count($result_count);


              /*
         * Output
         */
        $output = array(
            "draw" => intval($get['draw']),
            "recordsTotal" => $recordsTotal,
            "recordsFiltered" => $recordsTotal,
            "data" => array()
        );

        $url = $get['url'];
        $formUrl = '';
        $printPdfUrl = '';
        $hasUpdate = false;
        $hasPrint = false;

        if($userData['type'] == 'Super Admin'|| in_array('Room Update', $userData['accesses'])){

            $formUrl = $url . '/grooming/ajax_detail';  
            $hasUpdate = true;
        }

        
        if($userData['type'] == 'Super Admin'|| in_array('Billing PDF', $userData['accesses'])){

            $printPdfUrl = $url . '/grooming/invoice/pdf';  
            $hasPrint = true;
        }

        foreach($result as $row) {

            $id = base64_encode($row['id']);

            $action = $hasPrint ? '<a href="'.$printPdfUrl.'/'.$id.'" class="href-action-btn action-button-style btn btn-primary table-btn " target="_blank">Print PDF </a>' : "";

            $payments = "";
            $explodes = explode(',', $row['paymentTypes']);
            $dates = explode(',', $row['paymentDates']); //dates
            $amts = explode(',', $row['paymentAmts']); //dates
            $totalPayment = 0;

            $payments .= "<table>
            <thead>
                <tr>
                    <td>Payment Type</td>
                    <td>Payment Date</td>
                    <td>Payment Amount</td>
                </tr>
            </thead>";

            foreach($explodes as $k => $i){
   
                if($i != ''){

                    $totalPayment += intval($amts[$k]);
                    $payments .= "
                        <tbody>
                            <tr>
                                <td>".$i."</td>
                                <td>".$dates[$k]."</td>
                                <td> ".$amts[$k]." </td>
                            </tr>
                        </tbody>";
                }
          
            }

            $payments .= "</table>";


            $values = array(
                $row['transactionNo'],
                $row['client'],
                $payments,
                ($row['billedAmt'] - $totalPayment),
                $totalPayment,
                $action
            );

            $output['data'][] = $values;
        }

        unset($result);

        return $output;
    }


    public function todayGrooming($user){
       
        $firstDay  = date("Y-m-d 00:00:00" );
        $lastDay = date("Y-m-d 23:59:59");
        $query = $this->getEntityManager()->getConnection()->prepare("
                SELECT 
                    l.`id`                            
                FROM `grooming` l
                LEFT JOIN `client_pet` cp ON cp.`id` = l.`client_pet_id`
                LEFT JOIN `client` c ON c.`id` = cp.`client_id`
                WHERE c.`branch_id`= '".$user->getBranch()->getId() . "'
                AND  l.`created_at` BETWEEN '". $firstDay. "' AND '" .$lastDay. "' 
            
            ");

       
        $res = $query->executeQuery();
        $result = $res->fetchAllAssociative();

        return $result;

    }
  

}
